=== debian/changelog ===
dynarmic (6.4.0+ds-1) unstable; urgency=medium

  * New upstream version 6.4.0+ds
  * d/control: b-depend on libzydis-dev only on amd64
  * d/rules: enable A64 frontend on arm64

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 04 Dec 2022 15:31:27 +0100
