=== debian/control ===
Source: dynarmic
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.12),
               catch2,
               libboost-dev,
               libfmt-dev,
               libxbyak-dev [any-amd64],
               libzydis-dev (>= 4.0.0) [any-amd64],
               pkg-config,
               robin-map-dev
Standards-Version: 4.6.1
Homepage: https://github.com/merryhime/dynarmic
Vcs-Git: https://salsa.debian.org/debian/dynarmic.git
Vcs-Browser: https://salsa.debian.org/debian/dynarmic
Rules-Requires-Root: no
Description: ARM dynamic recompiler
 Dynarmic is a dynamic recompiler for the ARMv6K, ARMv7A architecture, with
 partial ARMv8 support.
 .
 In the pursuit of speed, some behavior not commonly depended upon is elided.
 Therefore this emulator does not match spec.

Package: libdynarmic6
Architecture: any-amd64 any-arm64
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: libdynarmic-dev
Section: libdevel
Architecture: any-amd64 any-arm64
Depends: libdynarmic6 (= ${binary:Version}), ${misc:Depends}
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains the development files.
