## dynarmic 6.4.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.12)
-project(dynarmic LANGUAGES C CXX ASM VERSION 6.4.0)
+project(dynarmic LANGUAGES C CXX ASM VERSION 6.4.3)
 
 # Determine if we're built as a subproject (using add_subdirectory)
 # or if this is the master project.
@@ -8,12 +8,14 @@
   set(MASTER_PROJECT ON)
 endif()
 
+include(CMakeDependentOption)
+
 # Dynarmic project options
 option(DYNARMIC_ENABLE_CPU_FEATURE_DETECTION "Turning this off causes dynarmic to assume the host CPU doesn't support anything later than SSE3" ON)
 option(DYNARMIC_ENABLE_NO_EXECUTE_SUPPORT "Enables support for systems that require W^X" OFF)
 option(DYNARMIC_FATAL_ERRORS "Errors are fatal" OFF)
 option(DYNARMIC_IGNORE_ASSERTS "Ignore asserts" OFF)
-option(DYNARMIC_TESTS "Build tests" ${MASTER_PROJECT})
+cmake_dependent_option(DYNARMIC_TESTS "Build tests" ${MASTER_PROJECT} "NOT DEFINED BUILD_TESTING" "${BUILD_TESTING}")
 option(DYNARMIC_TESTS_USE_UNICORN "Enable fuzzing tests against unicorn" OFF)
 option(DYNARMIC_USE_LLVM "Support disassembly of jitted x86_64 code using LLVM" OFF)
 option(DYNARMIC_USE_PRECOMPILED_HEADERS "Use precompiled headers" ON)
@@ -119,6 +121,7 @@
 if (DYNARMIC_USE_BUNDLED_EXTERNALS)
     set(CMAKE_DISABLE_FIND_PACKAGE_Catch2 ON)
     set(CMAKE_DISABLE_FIND_PACKAGE_fmt ON)
+    set(CMAKE_DISABLE_FIND_PACKAGE_mcl ON)
     set(CMAKE_DISABLE_FIND_PACKAGE_tsl-robin-map ON)
     set(CMAKE_DISABLE_FIND_PACKAGE_xbyak ON)
     set(CMAKE_DISABLE_FIND_PACKAGE_Zydis ON)
@@ -126,6 +129,7 @@
 
 find_package(Boost 1.57 REQUIRED)
 find_package(fmt 9 QUIET)
+find_package(mcl 0.1.12 EXACT QUIET)
 find_package(tsl-robin-map QUIET)
 
 if (ARCHITECTURE STREQUAL "x86" OR ARCHITECTURE STREQUAL "x86_64")
@@ -135,13 +139,10 @@
 
 if (DYNARMIC_USE_LLVM)
     find_package(LLVM REQUIRED CONFIG)
-    include_directories(${LLVM_INCLUDE_DIRS})
-    add_definitions(-DDYNARMIC_USE_LLVM ${LLVM_DEFINITIONS})
-    llvm_map_components_to_libnames(llvm_libs armdesc armdisassembler aarch64desc aarch64disassembler x86desc x86disassembler)
 endif()
 
 if (DYNARMIC_TESTS)
-    find_package(Catch2 2 QUIET)
+    find_package(Catch2 3 QUIET)
     if (DYNARMIC_TESTS_USE_UNICORN)
         find_package(Unicorn REQUIRED)
     endif()
@@ -153,7 +154,7 @@
 # Dynarmic project files
 add_subdirectory(src/dynarmic)
 if (DYNARMIC_TESTS)
-    enable_testing(true)
+    enable_testing()
     add_subdirectory(tests)
 endif()
