=== externals/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,12 @@
     set(BUILD_SHARED_LIBS OFF)
     set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 endif()
+
+# Allow options shadowing with normal variables when subproject use old cmake policy
+set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
+
+# Disable tests in all externals supporting the standard option name
+set(BUILD_TESTING OFF)
 
 # For libraries that already come with a CMakeLists file,
 # simply add the directory to that file as a subdirectory
@@ -10,10 +16,11 @@
 
 # catch
 
-if (NOT TARGET Catch2::Catch2)
+if (NOT TARGET Catch2::Catch2WithMain)
     if (DYNARMIC_TESTS)
-        add_library(Catch2::Catch2 INTERFACE IMPORTED GLOBAL)
-        target_include_directories(Catch2::Catch2 INTERFACE catch/include)
+        add_subdirectory(catch EXCLUDE_FROM_ALL)
+        list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/externals/catch/extras")
+        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} PARENT_SCOPE)
     endif()
 endif()
 
@@ -21,14 +28,14 @@
 
 if (NOT TARGET fmt::fmt)
     # fmtlib formatting library
-    option(FMT_INSTALL "" ON)
+    set(FMT_INSTALL ON)
     add_subdirectory(fmt EXCLUDE_FROM_ALL)
 endif()
 
 # mcl
 
 if (NOT TARGET merry::mcl)
-    option(MCL_INSTALL "" ON)
+    set(MCL_INSTALL ON)
     add_subdirectory(mcl EXCLUDE_FROM_ALL)
 endif()
 
@@ -58,10 +65,11 @@
 
 if (NOT TARGET Zydis::Zydis)
     if (ARCHITECTURE STREQUAL "x86" OR ARCHITECTURE STREQUAL "x86_64")
-        option(ZYDIS_BUILD_TOOLS "" OFF)
-        option(ZYDIS_BUILD_EXAMPLES "" OFF)
-        option(ZYDIS_BUILD_DOXYGEN "" OFF)
+        set(ZYDIS_BUILD_TOOLS OFF)
+        set(ZYDIS_BUILD_EXAMPLES OFF)
+        set(ZYDIS_BUILD_DOXYGEN OFF)
         set(ZYAN_ZYCORE_PATH "${CMAKE_CURRENT_LIST_DIR}/zycore" CACHE PATH "")
+        set(CMAKE_DISABLE_FIND_PACKAGE_Doxygen ON)
         add_subdirectory(zydis EXCLUDE_FROM_ALL)
         add_library(Zydis::Zydis ALIAS Zydis)
     endif()
