=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,6 @@
     fp/FPValue.cpp
     fp/mantissa_util_tests.cpp
     fp/unpacked_tests.cpp
-    main.cpp
     rand_int.h
 )
 
@@ -12,6 +11,7 @@
         A32/test_arm_disassembler.cpp
         A32/test_arm_instructions.cpp
         A32/test_coprocessor.cpp
+        A32/test_svc.cpp
         A32/test_thumb_instructions.cpp
         A32/testenv.h
         decoder_tests.cpp
@@ -21,6 +21,7 @@
 if ("A64" IN_LIST DYNARMIC_FRONTENDS)
     target_sources(dynarmic_tests PRIVATE
         A64/a64.cpp
+        A64/fp_min_max.cpp
         A64/misaligned_page_table.cpp
         A64/test_invalidation.cpp
         A64/testenv.h
@@ -78,13 +79,13 @@
 
     create_target_directory_groups(dynarmic_print_info)
 
-    target_link_libraries(dynarmic_print_info PRIVATE dynarmic Boost::boost Catch2::Catch2 fmt::fmt merry::mcl)
+    target_link_libraries(dynarmic_print_info PRIVATE dynarmic Boost::boost fmt::fmt merry::mcl)
     target_include_directories(dynarmic_print_info PRIVATE . ../src)
     target_compile_options(dynarmic_print_info PRIVATE ${DYNARMIC_CXX_FLAGS})
     target_compile_definitions(dynarmic_print_info PRIVATE FMT_USE_USER_DEFINED_LITERALS=1)
 endif()
 
-if ("A32" IN_LIST DYNARMIC_FRONTENDS)
+if (("A32" IN_LIST DYNARMIC_FRONTENDS) AND ("A64" IN_LIST DYNARMIC_FRONTENDS))
     add_executable(dynarmic_test_generator
         fuzz_util.cpp
         fuzz_util.h
@@ -93,7 +94,7 @@
 
     create_target_directory_groups(dynarmic_test_generator)
 
-    target_link_libraries(dynarmic_test_generator PRIVATE dynarmic Boost::boost Catch2::Catch2 fmt::fmt merry::mcl)
+    target_link_libraries(dynarmic_test_generator PRIVATE dynarmic Boost::boost fmt::fmt merry::mcl)
     target_include_directories(dynarmic_test_generator PRIVATE . ../src)
     target_compile_options(dynarmic_test_generator PRIVATE ${DYNARMIC_CXX_FLAGS})
     target_compile_definitions(dynarmic_test_generator PRIVATE FMT_USE_USER_DEFINED_LITERALS=1)
@@ -101,7 +102,7 @@
 
 create_target_directory_groups(dynarmic_tests)
 
-target_link_libraries(dynarmic_tests PRIVATE dynarmic Boost::boost Catch2::Catch2 fmt::fmt merry::mcl)
+target_link_libraries(dynarmic_tests PRIVATE dynarmic Boost::boost Catch2::Catch2WithMain fmt::fmt merry::mcl)
 target_include_directories(dynarmic_tests PRIVATE . ../src)
 target_compile_options(dynarmic_tests PRIVATE ${DYNARMIC_CXX_FLAGS})
 target_compile_definitions(dynarmic_tests PRIVATE FMT_USE_USER_DEFINED_LITERALS=1 CATCH_CONFIG_ENABLE_BENCHMARKING=1)
