=== src/dynarmic/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
 add_library(dynarmic
+    backend/exception_handler.h
     common/cast_util.h
     common/crypto/aes.cpp
     common/crypto/aes.h
@@ -282,4 +283,3 @@
         backend/x64/emit_x64_floating_point.cpp
         backend/x64/emit_x64_memory.h
         backend/x64/emit_x64_memory.cpp.inc
-        backend/x64/emit_x64_packed.cpp
