=== debian/changelog ===
dynarmic (6.4.3+ds-1) unstable; urgency=medium

  * New upstream version 6.4.3+ds
  * d/rules: enable LLVM backend
  * d/patches: revert Catch2 v3 switch.
    Catch2 version 3 won't be available in Debian for a while.

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 07 Jan 2023 12:49:07 +0100
