## dynarmic 6.4.4+ds

=== debian/changelog ===
dynarmic (6.4.4+ds-1) unstable; urgency=medium

  * New upstream version 6.4.4+ds

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 16 Jan 2023 23:30:37 +0100
