=== debian/control ===
--- 
+++ 
@@ -9,8 +9,10 @@
                libfmt-dev,
                libxbyak-dev [any-amd64],
                libzydis-dev (>= 4.0.0) [any-amd64],
+               llvm-dev,
                pkg-config,
-               robin-map-dev
+               robin-map-dev,
+               zlib1g-dev | libz-dev
 Standards-Version: 4.6.1
 Homepage: https://github.com/merryhime/dynarmic
 Vcs-Git: https://salsa.debian.org/debian/dynarmic.git
