## dynarmic 6.4.5%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.12)
-project(dynarmic LANGUAGES C CXX ASM VERSION 6.4.3)
+project(dynarmic LANGUAGES C CXX ASM VERSION 6.4.5)
 
 # Determine if we're built as a subproject (using add_subdirectory)
 # or if this is the master project.
@@ -8,14 +8,16 @@
   set(MASTER_PROJECT ON)
 endif()
 
-include(CMakeDependentOption)
+if (MASTER_PROJECT)
+    include(CTest)
+endif()
 
 # Dynarmic project options
 option(DYNARMIC_ENABLE_CPU_FEATURE_DETECTION "Turning this off causes dynarmic to assume the host CPU doesn't support anything later than SSE3" ON)
 option(DYNARMIC_ENABLE_NO_EXECUTE_SUPPORT "Enables support for systems that require W^X" OFF)
 option(DYNARMIC_FATAL_ERRORS "Errors are fatal" OFF)
 option(DYNARMIC_IGNORE_ASSERTS "Ignore asserts" OFF)
-cmake_dependent_option(DYNARMIC_TESTS "Build tests" ${MASTER_PROJECT} "NOT DEFINED BUILD_TESTING" "${BUILD_TESTING}")
+option(DYNARMIC_TESTS "Build tests" ${BUILD_TESTING})
 option(DYNARMIC_TESTS_USE_UNICORN "Enable fuzzing tests against unicorn" OFF)
 option(DYNARMIC_USE_LLVM "Support disassembly of jitted x86_64 code using LLVM" OFF)
 option(DYNARMIC_USE_PRECOMPILED_HEADERS "Use precompiled headers" ON)
@@ -132,7 +134,7 @@
 find_package(mcl 0.1.12 EXACT QUIET)
 find_package(tsl-robin-map QUIET)
 
-if (ARCHITECTURE STREQUAL "x86" OR ARCHITECTURE STREQUAL "x86_64")
+if ("x86_64" IN_LIST ARCHITECTURE)
     find_package(xbyak 6 QUIET)
     find_package(Zydis 4 QUIET)
 endif()
@@ -154,7 +156,6 @@
 # Dynarmic project files
 add_subdirectory(src/dynarmic)
 if (DYNARMIC_TESTS)
-    enable_testing()
     add_subdirectory(tests)
 endif()
